package com.sun.jndi.ldap.spi;

import javax.naming.NamingException;
import java.util.Optional;
import java.util.Map;

public abstract class LdapDnsProvider
{
    private static final RuntimePermission DNSPROVIDER_PERMISSION;
    
    protected LdapDnsProvider() {
        this(checkPermission());
    }
    
    private LdapDnsProvider(Void void1) {
    }
    
    private static Void checkPermission() {
        SecurityManager securityManager = System.getSecurityManager();
        if (securityManager != null) {
            securityManager.checkPermission(LdapDnsProvider.DNSPROVIDER_PERMISSION);
        }
        return null;
    }
    
    public abstract Optional<LdapDnsProviderResult> lookupEndpoints(String p0, Map<?, ?> p1) throws NamingException;
    
    static {
        DNSPROVIDER_PERMISSION = new RuntimePermission("ldapDnsProvider");
    }
}
